//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3B7AC09C018D.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3B7AC09C018D.cm

//## begin module%3B7AC09C018D.cp preserve=no
//## end module%3B7AC09C018D.cp

//## Module: StatMethod%3B7AC09C018D; Package body
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/StatMethod.cxx

//## begin module%3B7AC09C018D.additionalIncludes preserve=no
//## end module%3B7AC09C018D.additionalIncludes

//## begin module%3B7AC09C018D.includes preserve=yes
//## end module%3B7AC09C018D.includes

// Weight
#include <XSModel/GlobalContainer/Weight.h>
// StatMethod
#include <XSFit/Fit/StatMethod.h>


//## begin module%3B7AC09C018D.declarations preserve=no
//## end module%3B7AC09C018D.declarations

//## begin module%3B7AC09C018D.additionalDeclarations preserve=yes
#include <XSFit/Fit/Fit.h>
#include <XSFit/Fit/FitMethod.h>
#include <XSModel/Model/Model.h>
#include <XSModel/Data/SpectralData.h>
#include <XSModel/Data/DataUtility.h>
#include <XSModel/Data/Detector/Response.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/Parameter/ModParam.h>
#include <XSModel/Parameter/ResponseParam.h>
#include <XSUtil/Utils/XSstream.h>
#include <XSstreams.h>
#include <XSContainer.h>
#include <cmath>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <set>
using namespace XSContainer;
//## end module%3B7AC09C018D.additionalDeclarations


// Class StatMethod::InvalidSpectrumNumber 

StatMethod::InvalidSpectrumNumber::InvalidSpectrumNumber (size_t num)
  //## begin StatMethod::InvalidSpectrumNumber::InvalidSpectrumNumber%3C59951000AA.hasinit preserve=yes
  : RedAlert(" initializing spectra for fit:\n ")  
  //## end StatMethod::InvalidSpectrumNumber::InvalidSpectrumNumber%3C59951000AA.hasinit
  //## begin StatMethod::InvalidSpectrumNumber::InvalidSpectrumNumber%3C59951000AA.initialization preserve=yes
  //## end StatMethod::InvalidSpectrumNumber::InvalidSpectrumNumber%3C59951000AA.initialization
{
  //## begin StatMethod::InvalidSpectrumNumber::InvalidSpectrumNumber%3C59951000AA.body preserve=yes
  std::ostringstream message;
  message << " Statistic tried to access spectrum number " << num << " not loaded ";
  reportAndExit(message.str(),-5);
  //## end StatMethod::InvalidSpectrumNumber::InvalidSpectrumNumber%3C59951000AA.body
}


// Class StatMethod::InvalidParameterError 

StatMethod::InvalidParameterError::InvalidParameterError ()
  //## begin StatMethod::InvalidParameterError::InvalidParameterError%3C5AA9F301F7.hasinit preserve=yes
  : RedAlert(" retrieving model derivative array:\n")              
  //## end StatMethod::InvalidParameterError::InvalidParameterError%3C5AA9F301F7.hasinit
  //## begin StatMethod::InvalidParameterError::InvalidParameterError%3C5AA9F301F7.initialization preserve=yes
  //## end StatMethod::InvalidParameterError::InvalidParameterError%3C5AA9F301F7.initialization
{
  //## begin StatMethod::InvalidParameterError::InvalidParameterError%3C5AA9F301F7.body preserve=yes
  std::ostringstream message;
  message << " Statistic calculation attempted to retrieve parameter derivative not allocated ";
  reportAndExit(message.str(),-5);
  //## end StatMethod::InvalidParameterError::InvalidParameterError%3C5AA9F301F7.body
}


// Class StatMethod::FitNotDefined 

StatMethod::FitNotDefined::FitNotDefined (const string& diag)
  //## begin StatMethod::FitNotDefined::FitNotDefined%3CF4DFA801F5.hasinit preserve=yes
  : YellowAlert (" no model defined or no data read ")
  //## end StatMethod::FitNotDefined::FitNotDefined%3CF4DFA801F5.hasinit
  //## begin StatMethod::FitNotDefined::FitNotDefined%3CF4DFA801F5.initialization preserve=yes
  //## end StatMethod::FitNotDefined::FitNotDefined%3CF4DFA801F5.initialization
{
  //## begin StatMethod::FitNotDefined::FitNotDefined%3CF4DFA801F5.body preserve=yes
  tcerr << diag << '\n';
  //## end StatMethod::FitNotDefined::FitNotDefined%3CF4DFA801F5.body
}


// Class StatMethod::NoSuchSpectrum 

StatMethod::NoSuchSpectrum::NoSuchSpectrum (const string& diag)
  //## begin StatMethod::NoSuchSpectrum::NoSuchSpectrum%3CF4E70B017D.hasinit preserve=yes
  : YellowAlert(" spectrum not loaded ")
  //## end StatMethod::NoSuchSpectrum::NoSuchSpectrum%3CF4E70B017D.hasinit
  //## begin StatMethod::NoSuchSpectrum::NoSuchSpectrum%3CF4E70B017D.initialization preserve=yes
  //## end StatMethod::NoSuchSpectrum::NoSuchSpectrum%3CF4E70B017D.initialization
{
  //## begin StatMethod::NoSuchSpectrum::NoSuchSpectrum%3CF4E70B017D.body preserve=yes
  //## end StatMethod::NoSuchSpectrum::NoSuchSpectrum%3CF4E70B017D.body
}


// Class StatMethod 

//## begin StatMethod::bayes%4224A50401DC.attr preserve=no  protected: static Bayes {U} Bayes()
Bayes StatMethod::s_bayes = Bayes();
//## end StatMethod::bayes%4224A50401DC.attr


//## begin StatMethod::statMethods%3B7AC8A400EE.role preserve=no  public: static StatMethod { -> 1..nRHgN}
std::map<std::string, StatMethod*> StatMethod::s_statMethods;
//## end StatMethod::statMethods%3B7AC8A400EE.role

//## begin StatMethod::weightScheme%3C435433013F.role preserve=no  public: static XSContainer::Weight { -> 1..nRFHgN}
std::map<string, XSContainer::Weight*> StatMethod::s_weightScheme;
//## end StatMethod::weightScheme%3C435433013F.role

StatMethod::StatMethod(const StatMethod &right)
  //## begin StatMethod::StatMethod%3A7EC4660115_copy.hasinit preserve=yes
  : m_statistic(right.m_statistic),
    m_isDerivAnalytic(right.m_isDerivAnalytic),
    m_alpha(right.m_alpha),
    m_name(right.m_name),
    m_weight(0),
    m_beta(right.m_beta),
    m_dModel(right.m_dModel),
    m_protoWorkspace(right.m_protoWorkspace),
    m_dRM(right.m_dRM)               
  //## end StatMethod::StatMethod%3A7EC4660115_copy.hasinit
  //## begin StatMethod::StatMethod%3A7EC4660115_copy.initialization preserve=yes
  //## end StatMethod::StatMethod%3A7EC4660115_copy.initialization
{
  //## begin StatMethod::StatMethod%3A7EC4660115_copy.body preserve=yes
  if (right.m_weight) m_weight = right.m_weight->clone();
  //## end StatMethod::StatMethod%3A7EC4660115_copy.body
}

StatMethod::StatMethod (const std::string& name)
  //## begin StatMethod::StatMethod%3A7EC4BE02E8.hasinit preserve=yes
  : m_statistic(0.),
    m_isDerivAnalytic(false),
    m_alpha(),
    m_name(name),
    m_weight(0),
    m_beta(),
    m_dModel(),
    m_protoWorkspace(),
    m_dRM()
  //## end StatMethod::StatMethod%3A7EC4BE02E8.hasinit
  //## begin StatMethod::StatMethod%3A7EC4BE02E8.initialization preserve=yes
  //## end StatMethod::StatMethod%3A7EC4BE02E8.initialization
{
  //## begin StatMethod::StatMethod%3A7EC4BE02E8.body preserve=yes
  //## end StatMethod::StatMethod%3A7EC4BE02E8.body
}


StatMethod::~StatMethod()
{
  //## begin StatMethod::~StatMethod%3A7EC4660115_dest.body preserve=yes
  delete m_weight;
  //## end StatMethod::~StatMethod%3A7EC4660115_dest.body
}



//## Other Operations (implementation)
void StatMethod::differentiate (Fit* fit, const IntegerArray& which)
{
  //## begin StatMethod::differentiate%3B7A98E60078.body preserve=yes
   if (m_isDerivAnalytic && !fit->useNumericalDifferentiation())
      analyticDifferentiate(fit, which);
   else
      numericalDifferentiate(fit, which);
  //## end StatMethod::differentiate%3B7A98E60078.body
}

StatMethod* StatMethod::get (const std::string& name)
{
  //## begin StatMethod::get%3B7AC9C00310.body preserve=yes
  std::map<std::string,StatMethod*>::iterator f(s_statMethods.find(name));
  if (f != s_statMethods.end()) return (*f).second->clone();
  else return 0;
  //## end StatMethod::get%3B7AC9C00310.body
}

void StatMethod::registerMethod (const string& name, StatMethod* method)
{
  //## begin StatMethod::registerMethod%3BFABE250331.body preserve=yes
  s_statMethods.insert(std::map<std::string,StatMethod*>::value_type(name,method));
  //## end StatMethod::registerMethod%3BFABE250331.body
}

void StatMethod::registerWeightingMethod (const std::string& name, XSContainer::Weight* weightMethod)
{
  //## begin StatMethod::registerWeightingMethod%3C3F65630169.body preserve=yes
  s_weightScheme.insert(std::map<std::string, XSContainer::Weight*>::value_type(name,weightMethod));
  //## end StatMethod::registerWeightingMethod%3C3F65630169.body
}

XSContainer::Weight* StatMethod::weightScheme (const std::string& name)
{
  //## begin StatMethod::weightScheme%3C443FE103A3.body preserve=yes
  string lcName = XSutility::lowerCase(name);
  XSContainer::Weight* requested = 0;
  std::map<std::string,XSContainer::Weight*>::const_iterator iw = s_weightScheme.lower_bound(lcName);
  if (iw != s_weightScheme.end()) 
  {
     if (iw->first.find(lcName) == 0)
     {
        requested = iw->second;
     }
  }
  return requested;
  //## end StatMethod::weightScheme%3C443FE103A3.body
}

void StatMethod::setWeight (const std::string& weightName)
{
  //## begin StatMethod::setWeight%3C4EF50803C8.body preserve=yes
  static const string STANDARD ("standard");
  // Default setWeight only accepts standard weighting.
  const string lcName = XSutility::lowerCase(weightName);
  if (STANDARD.find(lcName) != 0)
  {
        tcout << "*** Warning: statistic " << m_name << " does not recognize weighting \n"
                << " scheme " << weightName << ": using standard weighting" << std::endl; 
  }
  else
  {
     tcout << " " << m_name << " statistic: variance weighted using standard weighting"
          << std::endl;
  }
  weight(weightScheme(std::string("standard")));
  //## end StatMethod::setWeight%3C4EF50803C8.body
}

void StatMethod::initialize (Fit* fit)
{
  //## begin StatMethod::initialize%3C598D9D0155.body preserve=yes
        
  doInitialize(fit);
        
  //## end StatMethod::initialize%3C598D9D0155.body
}

void StatMethod::doInitialize (Fit* fit)
{
  //## begin StatMethod::doInitialize%3C598DC800CE.body preserve=yes
  
  // clear all and start again.
  deallocate();
  // allocate memory for derivative arrays. If derivatives are not
  // required we don't need to do anything.
  
  // create proto workspace
  
  std::map<size_t,SpectralData*>::const_iterator sp (fit->spectraToFit().begin());
  std::map<size_t,SpectralData*>::const_iterator spEnd (fit->spectraToFit().end());
  
  while (sp != spEnd)
  {
        size_t N = sp->second->indirectNotice().size();
        m_protoWorkspace.insert(ArrayContainer::value_type(sp->first,RealArray(0.,N)));  
        ++sp;       
  }
  
                    
  if (fit->fitMethod()->firstDerivativeRequired())
  {
        size_t numFreeParam = fit->variableParameters().size();
        m_beta.resize(numFreeParam,0.);

        
        std::map<int,ModParam*>::const_iterator vp = fit->variableParameters().begin();
        std::map<int,ModParam*>::const_iterator vpEnd = fit->variableParameters().end();

        // one derivative arrayContainer per variable parameter per source
        // and one real array per spectrum is required. 
        // Because of linked parameters, more than one model
        // can contribute to the derivative with respect to an individual spectrum.
        while (vp != vpEnd)
        {
            m_dModel.insert(std::map<size_t,ArrayContainer>::value_type(vp->first,protoWorkspace()));                                
            ++vp;        
        }
        //the original plan was to size the derivative arrays here, but that
        // would be rather complicated because in practice it would mean extracting
        // data group information and comparing it with parameter indexing to
        // see which parameters belonged to each data group. In any case many of the
        // derivative arrays will be zero, so it's probably more efficient to 
        // resize on the first iteration and then to check the size at subsequent
        // iterations. But we can determine how large the derivative array container
        // will be here.
                
        
        if (fit->fitMethod()->secondDerivativeRequired())
        {
                m_alpha.resize(numFreeParam*numFreeParam,0.0);       
        }       
          
  }
  //## end StatMethod::doInitialize%3C598DC800CE.body
}

void StatMethod::deallocate ()
{
  //## begin StatMethod::deallocate%3C5AACD200A3.body preserve=yes

        doDeallocate();
        
  //## end StatMethod::deallocate%3C5AACD200A3.body
}

void StatMethod::doDeallocate ()
{
  //## begin StatMethod::doDeallocate%3C5AAD060261.body preserve=yes
        m_alpha.resize(0);
        m_beta.resize(0);
        m_dModel.clear(); 
        m_protoWorkspace.clear(); 
        m_dRM.clear();  
  //## end StatMethod::doDeallocate%3C5AAD060261.body
}

void StatMethod::renormalize (Fit* fit)
{
  //## begin StatMethod::renormalize%3C5FF135039D.body preserve=yes
        
        if (  models->activeModelNames().empty() || datasets->numberOfSpectra() == 0)
        {
                throw Fit::CantInitialize(" renorm: either no model defined or no data read ");      
        
        }
        else
        {
           if (m_name == "cstat" || m_name == "lstat")
           {
              // These stat methods aren't set up for renorming with
              // background data.  
              for (DataArrayConstIt itDs = datasets->dataArray().begin(); 
                    itDs != datasets->dataArray().end(); ++itDs)
              {
                 const DataSet* ds = itDs->second;
                 if (ds->isMultiple())
                 {
                    SpectralDataMapConstIt itSd = ds->multiSpectralData().begin();
                    while (itSd != ds->multiSpectralData().end())
                    {
                       const SpectralData* sd = itSd->second;
                       if (sd && sd->background())  return;
                       ++itSd;
                    }
                 }
                 else if (const SpectralData* sd = ds->spectralData())
                 {
                    if (sd->background())  return;
                 }
              }
           }
           // perform the renormalization...
           ModelMapConstIter mod (models->modelSet().begin());
           ModelMapConstIter modEnd (models->modelSet().end());

           // first, compute and store current model.
           std::map<Model*,bool> frozenComponents;

           size_t numberOfNorms (0);
           size_t numberOfFrozenNorms(0);
           while ( mod != modEnd )
           {
              Model* currentModel = mod->second;
              frozenComponents[currentModel] = false;
              if ( currentModel->isActive() ) 
              {                   
                 std::list<ModParam*> norms (currentModel->normParams());
                 numberOfNorms += norms.size();
                 for (std::list<ModParam*>::const_iterator np = norms.begin();
                      np != norms.end(); ++np)
                 {
                     if ((*np)->isFrozen() || Parameter::isLinkedToFrozen(*np))
                     {
	                frozenComponents[currentModel] = true; 
                        ++numberOfFrozenNorms;
                     }            
                 }  
              }
              ++mod;
           }
           if (numberOfFrozenNorms == numberOfNorms )
           {
               if (!fit->errorCalc())
               {        
                   tcout << " Warning: renorm - no variable model to allow  renormalization"
                         << std::endl; 
               }   
           }
           else
           {
              mod    = models->modelSet().begin();

              std::pair<Real,Real> fSums;
              Real ofSum(0.);    // =>     fSums[0]
              Real mfSum(0.);    // =>     fSums[1]
              doReset(fit);

              // Want to analyze spectra grouped by data group number.
              // DataContainer currently provides no ready-made way to
              // do this, so in order to avoid O(N^2) behavior let's
              // collate things here.
              const size_t nDgs = datasets->numberOfGroups();
              const size_t nSpecs = datasets->numberOfSpectra();
              std::vector<std::vector<const SpectralData*> > specsByGroup(nDgs);
              for (size_t iSp=1; iSp<=nSpecs; ++iSp)
              {
                 const SpectralData* spec = datasets->lookup(iSp);
                 const size_t dgNum = spec->parent()->dataGroup();
                 specsByGroup[dgNum-1].push_back(spec);
              }
              
              for (size_t iDg=0; iDg<nDgs; ++iDg)
              {
                 std::vector<Model*> modsForGroup(datasets->numSourcesForSpectra(),0);
                 std::map<Model*,ArrayContainer > saveFrozenModVals;
                 const std::set<size_t>& sourcesForGroup =  
                        datasets->dgToSources().find(iDg+1)->second;
                 std::set<size_t>::const_iterator itSource =
                        sourcesForGroup.begin();
                 std::set<size_t>::const_iterator itSourceEnd =
                        sourcesForGroup.end();
                 while (itSource != itSourceEnd)
                 {
                    const string modName = models->lookupModelForSource(*itSource);
                    if (modName.length())
                    {
                       // Model must be active/on if in here.
                       Model* mod = models->lookup(modName, iDg+1);
                       modsForGroup[*itSource-1] = mod;
                       mod->fold();
                       if (frozenComponents[mod])
                       {
                          ArrayContainer& savModVal = saveFrozenModVals[mod];
                          ArrayContainer::const_iterator it = mod->foldedModel().begin();
                          ArrayContainer::const_iterator itEnd = mod->foldedModel().end();
                          while (it != itEnd)
                          {
                             savModVal.insert(ArrayContainer::value_type(it->first,it->second));
                             ++it;
                          }
                          mod->calculate(false, true);
                          mod->fold();
                       }
                    }
                    ++itSource;
                 }
                                  
                 const std::vector<const SpectralData*>& specsForGroup = 
                                specsByGroup[iDg];
                 for (size_t iSp=0; iSp<specsForGroup.size(); ++iSp)
                 {
                    const SpectralData* spec = specsForGroup[iSp];
                    const std::vector<Response*>& detectors = spec->detector();
                    std::vector<Model*> modsForSpec;
                    for (size_t iDet=0; iDet<detectors.size(); ++iDet)
                    {
                       if (detectors[iDet])
                       {
                          if (modsForGroup[iDet])
                             modsForSpec.push_back(modsForGroup[iDet]);
                       }
                    }
                    // adjustForFrozen functions ASSUME at least one 
                    // model is applied to spec, so filter out no model 
                    // case here.
                    if (modsForSpec.size())
                    {
                       fSums = adjustForFrozen(spec, modsForSpec, saveFrozenModVals);
                       ofSum += fSums.first;
                       mfSum += fSums.second;
                    }
                 } 
              } 


              Real renorm(1.);
              if(std::abs(ofSum - mfSum) < SMALL)
              {
                  if (!fit->errorCalc())
                  {
                      tcout << " renorm: no renormalization necessary" <<std::endl;   
                  }
              }
              else if(std::abs(mfSum) > SMALL)
              { 
	          renorm = ofSum / mfSum;
                  mod = models->modelSet().begin();
                  while (mod != modEnd)
                  {
	              Model* currentModel (mod->second);
                      if ( currentModel->isActive()) 
                      {
	                 std::list<ModParam*> norms (currentModel->normParams());
	                 std::list<ModParam*>::iterator np = norms.begin();
	                 std::list<ModParam*>::iterator npEnd = norms.end();
	                 while (np != npEnd)
	                 {
		             if (!(*np)->isFrozen() && !(*np)->isLinked())
		             {
		                 Real newValue = (*np)->value()*renorm;
		                 newValue = std::max( (*np)->value('l'),
					      std::min(newValue,(*np)->value('h')));
		                 (*np)->setValue(newValue,'v');
		             }
		             ++np;       
	                 }
                      }
	              ++mod;
                  }
              }
           } // end frozenNorms != numNorms

        }
  //## end StatMethod::renormalize%3C5FF135039D.body
}

string StatMethod::weightNames ()
{
  //## begin StatMethod::weightNames%3C83B9C500DE.body preserve=yes
  std::map<string,XSContainer::Weight*>::const_iterator ws = s_weightScheme.begin();
  std::map<string,XSContainer::Weight*>::const_iterator wsEnd = s_weightScheme.end();
  string names("");
  while ( ws != wsEnd)
  {
          names += ws->first;
          ++ws;       
          if (ws != wsEnd) names += " | ";
          else names += " ";
  }
        
  return names;      
  //## end StatMethod::weightNames%3C83B9C500DE.body
}

string StatMethod::statNames ()
{
  //## begin StatMethod::statNames%3C83B9D90119.body preserve=yes
  std::map<string,StatMethod*>::const_iterator sm = s_statMethods.begin();
  std::map<string,StatMethod*>::const_iterator smEnd = s_statMethods.end();
  string names("");
  while ( sm != smEnd)
  {
          names += sm->first;
          ++sm;       
          if (sm != smEnd) names += " | ";
          else names += " ";
  }
        
  return names;      
  //## end StatMethod::statNames%3C83B9D90119.body
}

void StatMethod::degreesOfFreedom (Fit* fit, int& degrees, size_t& bins) const
{
  //## begin StatMethod::degreesOfFreedom%3C87D3D70102.body preserve=yes
        // compute the number of degrees of freedom for a fit.
        std::map<size_t,SpectralData*>::const_iterator   sm (fit->spectraToFit().begin());
        std::map<size_t,SpectralData*>::const_iterator   smEnd (fit->spectraToFit().end());

        while (  sm != smEnd )
        {
                bins += sm->second->indirectNotice().size();
                ++sm;
        }      
        
        degrees = bins - fit->variableParameters().size();

  //## end StatMethod::degreesOfFreedom%3C87D3D70102.body
}

void StatMethod::report (Fit* fit) const
{
  //## begin StatMethod::report%3C90CE980078.body preserve=yes
        
  int dof = 0;
  size_t bins = 0;
  degreesOfFreedom(fit, dof, bins);
  if (dof < 0)
  {
     tcout << "Ill-formed Fit problem - number of variable parameters exceeds number of bins"
        << std::endl;
  }
  else
  { 
     if (!fit->spectraToFit().empty() && !fit->activeModels().empty())
        doReport(fit);
     if (!fit->isStillValid())
        tcout << " Current data and model not fit yet." << std::endl;
  }
  
  //## end StatMethod::report%3C90CE980078.body
}

void StatMethod::resetDerivativeArrays ()
{
  //## begin StatMethod::resetDerivativeArrays%3CA33F6403DD.body preserve=yes
  // is it quicker to trash the arrays and reallocate arrays initialized to
  // zero? I doubt it. Anyway, all of the arrays here are valarrays and
  // so the code is very simple.
  m_alpha = 0.;
  m_beta  = 0.;
  
  std::map<size_t,ArrayContainer >::iterator  dm = m_dModel.begin();
  std::map<size_t,ArrayContainer >::iterator  dmEnd = m_dModel.end();   
  while ( dm != dmEnd )
  {
        ArrayContainer::iterator dmsp    = dm->second.begin();
        ArrayContainer::iterator dmspEnd = dm->second.end();
        while ( dmsp != dmspEnd)
        {
                dmsp->second = 0.;
                ++dmsp;  
        }
        ++dm;       
  } 
    
  //## end StatMethod::resetDerivativeArrays%3CA33F6403DD.body
}

void StatMethod::peakResidual (const Fit* fit, std::pair<Real,Real>& max, std::pair<Real,Real>& min, size_t spectrum, const std::pair<Real,Real> range) const
{
  //## begin StatMethod::peakResidual%3CF3F23C0244.body preserve=yes
  
  ArrayContainer difference (getDifferences(fit));
  
  doPeakResidual(fit,difference,max,min,spectrum,range);
  //## end StatMethod::peakResidual%3CF3F23C0244.body
}

void StatMethod::doPeakResidual (const Fit* fit, const ArrayContainer& difference, std::pair<Real,Real>& max, std::pair<Real,Real>& min, size_t spectrum, const std::pair<Real,Real> range) const
{
  //## begin StatMethod::doPeakResidual%3CF3F2BF02BB.body preserve=yes
        
  if ( fit->activeModels().empty() || fit->spectraToFit().empty()) 
  {          
     throw StatMethod::FitNotDefined(" : Peak Residual");
  }

  
  std::map<size_t,SpectralData*>::const_iterator sm = fit->spectraToFit().find(spectrum);
  if (sm == fit->spectraToFit().end()) 
  {
     throw YellowAlert("No response*model associated with spectrum\n");   
  }
  
  SpectralData* sp = sm->second;
  ArrayContainer::const_iterator f = difference.find(spectrum);
  const RealArray& residual  = f->second;
  const std::valarray<size_t>& IN = sp->indirectNotice();
  int M (IN.size());
  int lower(0);
  int upper(M-1);
  if ( range.first != 0 && range.second != 0)
  {
     sp->energyChannel(range.first,lower);
     sp->energyChannel(range.second,upper);
  }
  Real maxResid (-LARGE);
  Real maxEnergy (0);
  

  Real minResid (LARGE);
  Real minEnergy (0);
  int jmax (0),jmin (0);
  for (int j = lower; j <= upper; ++j)
  {
     Real resid = residual[j];
     if (resid > maxResid) 
     {
        maxResid = resid;
        maxEnergy = sp->channelEnergy(j);
        jmax = j;
     }         
     if (resid < minResid) 
     {
        minResid = resid;
        minEnergy = sp->channelEnergy(j);
        jmin = j;
     } 
  }

  int nResps = 0;
  Real minEffArea = 0.0;
  Real maxEffArea = 0.0;     
  for (size_t i=0; i<sp->detector().size(); ++i)
  {
     const Response* rsp = sp->detector(i);
     if (rsp)
     {
        int idx;
        XSutility::find(rsp->energies(), maxEnergy, idx);
        const RealArray& effectiveArea = rsp->efficiency();
        if (idx < 0 || static_cast<size_t>(idx) >= effectiveArea.size())
        {
           // This should never happen
           throw YellowAlert("Peak resid energy is outside effective area array\n");
        }
        maxEffArea += effectiveArea[idx];
        XSutility::find(rsp->energies(), minEnergy, idx);
        if (idx < 0 || static_cast<size_t>(idx) >= effectiveArea.size())
        {
           // This should never happen
           throw YellowAlert("Peak resid energy is outside effective area array\n");
        }
        minEffArea += effectiveArea[idx];
        ++nResps;
     }
  }
  // nResps must be > 0 or it would have been caught above.
  maxEffArea /= static_cast<Real>(nResps);
  if (maxEffArea == 0.0)
     throw YellowAlert("Zero effective area for bin: Cannot calculate peak strength.\n");
  minEffArea /= static_cast<Real>(nResps);
  if (minEffArea == 0.0)
     throw YellowAlert("Zero effective area for bin: Cannot calculate peak strength.\n");
  max.first = maxResid/maxEffArea;
  max.second = maxEnergy;
  min.first = minResid/minEffArea;
  min.second = minEnergy;
  
  //## end StatMethod::doPeakResidual%3CF3F2BF02BB.body
}

Real StatMethod::sumDerivs (int parameterIndex, bool isRespar)
{
  //## begin StatMethod::sumDerivs%3D04DB7D0044.body preserve=yes
   return .0;
  //## end StatMethod::sumDerivs%3D04DB7D0044.body
}

void StatMethod::getWeightDerivs (Fit* fit)
{
  //## begin StatMethod::getWeightDerivs%3D04DBD50293.body preserve=yes
  //## end StatMethod::getWeightDerivs%3D04DBD50293.body
}

Real StatMethod::plotChi (Real obs, Real mod, Real error, Real areaTime, const Real& NODATA) const
{
  //## begin StatMethod::plotChi%3DD26EB200FE.body preserve=yes
  //## end StatMethod::plotChi%3DD26EB200FE.body

  return 0;
}

Real StatMethod::plotDeltaChi (Real obs, Real mod, Real error, const Real& NODATA) const
{
  //## begin StatMethod::plotDeltaChi%3DD26EBA0278.body preserve=yes
  //## end StatMethod::plotDeltaChi%3DD26EBA0278.body

  return 0;
}

Real StatMethod::sumSecondDerivs (int pi, int pj, bool isPiResp, bool isPjResp)
{
  //## begin StatMethod::sumSecondDerivs%4166FC680073.body preserve=yes
   return .0;
  //## end StatMethod::sumSecondDerivs%4166FC680073.body
}

void StatMethod::clearMethods ()
{
  //## begin StatMethod::clearMethods%429F4C690378.body preserve=yes
   std::map<std::string, StatMethod*>::iterator itSm = s_statMethods.begin();
   std::map<std::string, StatMethod*>::iterator itEnd = s_statMethods.end();
   while (itSm != itEnd)
   {
      delete itSm->second;
      ++itSm;
   }
   s_statMethods.clear();
  //## end StatMethod::clearMethods%429F4C690378.body
}

void StatMethod::clearWeightingMethods ()
{
  //## begin StatMethod::clearWeightingMethods%429F4D9C01F9.body preserve=yes
   std::map<std::string, XSContainer::Weight*>::iterator itWs = s_weightScheme.begin();
   std::map<std::string, XSContainer::Weight*>::iterator itEnd = s_weightScheme.end();
   while (itWs != itEnd)
   {
      delete itWs->second;
      ++itWs;
   }
   s_weightScheme.clear();
  //## end StatMethod::clearWeightingMethods%429F4D9C01F9.body
}

Real StatMethod::setOutputFormat (Fit* fit, int degrees) const
{
  //## begin StatMethod::setOutputFormat%4343FA650032.body preserve=yes
   using namespace std;
   Real deltaCrit = fit->fitMethod()->deltaCrit();
   if (deltaCrit <= 0.0)  
      throw YellowAlert("Zero or neg critical delta detected in StatMethod::setOutputFormat.\n");
   Real truncatedStat = .0;
   Real absStatistic = m_statistic;
   if (m_statistic == 0.0)
   {
      // just print 0.0
      tcout << fixed << setprecision(1);
   }
   else
   {
      if (m_statistic < .0)
         absStatistic *= -1.0;
      int expDelta = static_cast<int>(floor(log10(deltaCrit)));
      int expStat = static_cast<int>(floor(log10(absStatistic)));
      int nDigits = expStat - expDelta + 1;
      if (nDigits <= 0)
      {
         // This case shouldn't really ever happen, but on the outside
         // chance, adjust expDelta to give 1 digit.
         expDelta = expStat;
         nDigits = 1;
      }
      Real stat = absStatistic;
      int lowestExp = expDelta;
      if (degrees)
      {
         // We're dealing with a reduced-chisq calc.  
         // nDigits should remain the same.
         stat /= degrees;
         expStat = static_cast<int>(floor(log10(stat)));
         lowestExp = expStat - nDigits + 1;
      }
      double truncator = pow(10.0, lowestExp);
      truncatedStat = floor(stat/truncator + .5)*truncator;
      if (expStat > 5 || expStat < -3)
      {
         if (nDigits == 1)
         {
            // use general format
            tcout.setf(ios_base::fmtflags(0), ios_base::floatfield);
            tcout.precision(1);
         }
         else
         {
            int prec = min(nDigits-1, 6);
            tcout << scientific << setprecision(prec);
         }
      }
      else
      {
         int prec = (lowestExp < 0) ? -lowestExp : 0;
         prec = min(prec, 6-expStat);
         tcout << fixed << setprecision(prec);
      }
      // Put back the '-' if there is one.
      if (m_statistic < .0)
         truncatedStat *= -1.0;
   }
   return truncatedStat;
  //## end StatMethod::setOutputFormat%4343FA650032.body
}

void StatMethod::numericalDifferentiate (Fit* fit, const IntegerArray& parNums)
{
  //## begin StatMethod::numericalDifferentiate%45B0DAF5013E.body preserve=yes
   using namespace XSContainer;
   using namespace std;
   
   const size_t nPars = parNums.size();
   RealArray dPars(.0,nPars);
   for (size_t i=0; i<nPars; ++i)
   {
      ModParam* par = fit->variableParameters(parNums[i]);
      Real origVal = par->value('a');
      Real delta = par->value('d');      
      par->setValue(origVal+delta,'a');      
      perform(fit);
      Real plusDeltaStat = m_statistic;
      par->setValue(origVal-delta,'a');
      perform(fit);
      Real minusDeltaStat = m_statistic;
      dPars[i] = delta;
      par->setValue(origVal,'a');
      beta(i,-.25*(plusDeltaStat-minusDeltaStat)/delta);
   }
   if (fit->fitMethod()->secondDerivativeRequired())
   {
      size_t i=0;
      RealArray alphaElems(0.0,nPars*nPars);
      // Calculate:
      // [(S(pi+di,pj+dj)-S(pi-di,pj+dj))-(S(pi+di,pj-dj)-S(pi-di,pj-dj))]/(4di*dj)
      while (i < nPars)
      {
         ModParam* par_i = fit->variableParameters(parNums[i]);
         const Real orig_i = par_i->value('a');
         const size_t iPos = i*nPars;
         const Real dPars_i = dPars[i];
         for (int iDel=1; iDel>=-1; iDel-=2)
         {
            par_i->setValue(orig_i+iDel*dPars_i,'a');
            size_t j=0;
            while (j <= i)
            {
               ModParam* par_j = fit->variableParameters(parNums[j]);
               Real orig_j = par_j->value('a');
               for (int jDel=1; jDel>=-1; jDel-=2)
               {
                  par_j->setValue(orig_j+jDel*dPars[j],'a');
                  perform(fit);
                  const size_t jElem = j+iPos;
                  alphaElems[jElem] += iDel*jDel*m_statistic/(dPars_i*dPars[j]);
                  if (i != j)
                     alphaElems[i + nPars*j] = alphaElems[jElem];
               }
               par_j->setValue(orig_j,'a');
               ++j;
            }
         }
         par_i->setValue(orig_i,'a');
         ++i;
      }
      alphaElems /= 8.0;
      setAlpha(alphaElems);
   }
   // This will reset all model fluxes as well as statistic.
   perform(fit);
  
  //## end StatMethod::numericalDifferentiate%45B0DAF5013E.body
}

void StatMethod::analyticDifferentiate (Fit* fit, const IntegerArray& parNums)
{
  //## begin StatMethod::analyticDifferentiate%45B0DB84028A.body preserve=yes
        
    // differentiate the statistic with respect to parameters with
    // indices specified by parNums.

    // The m_difference array will contain the quantity
    // d = (D-F), the m_variance array will contain the variance var, 
    // corrected for any model systematic terms. Calculation of m_difference
    // is done in Model::difference(ArrayContainer&) which is invoked by
    // ChiSquare::doPerform

    // NOTE finally that since each model's parameters are independent of the other
    // models, the result of all this  will be one set of derivative arrays 
    // per model per spectrum. This is different from  the case of chisquare itself,
    // in which the difference can depend on two models simultaneously.
    using namespace XSContainer;
    using std::vector;
    using std::set;      
    getWeightDerivs(fit);

    const size_t N = parNums.size();
    size_t np (0);
    bool saveComponentFlux(true);
    static const int respFloor = Fit::RESPAR_INDEX() << ModelContainer::SHIFT();
    m_dRM.clear();
    for (size_t k = 0; k < N; ++k)
    {
       bool isRespar = false;
       int parNum = parNums[k];
       ModParam* pj (fit->variableParameters(parNum));
       Real p (pj->value('a'));
       Real delta (pj->value('d'));
       
        // results for each spectrum at parameter indexed by k.

        ArrayContainer& dm = m_dModel[parNum];


        set<string>::const_iterator ss    (fit->activeModels().begin());
        set<string>::const_iterator ssEnd (fit->activeModels().end());

        while ( ss != ssEnd )
        {
           // forward difference  
           const string& modelName = *ss;

           pj->setValue(p + delta,'a');
           // save the model and component fluxes to avoid unnecessary recalculation.
           GroupFluxContainer saveFlux;
           models->storeFluxes(modelName, saveFlux);
           models->calculate(modelName, saveComponentFlux);

           // save results in 'difference' container
           GroupFluxContainer forwardDifference;
           models->storeFluxes(modelName, forwardDifference);

           // backward difference
           pj->setValue(p - delta,'a');
           models->calculate(modelName);

           // difference contains the forward difference and the models
           // contain the backward difference. Combine these into a derivative,
           // fold, and return the value in dm

           models->makeDerivatives(modelName, forwardDifference, delta, dm);

           // ... and put the model back straight afterwards.

           models->restoreFluxes (modelName, saveFlux);
           models->resetComponentFluxes(modelName);

           ++ss;       
        }
        pj->setValue(p,'z');
        // Rather than do a dynamic_cast to tell if this is a
        // ResponseParam, simply rely on the fact that ResponseParams
        // are given an index above a set value.
        if (parNum > respFloor)
        {
           ResponseParam* rpj = dynamic_cast<ResponseParam*>(pj);
           if (!rpj)
           {
              throw RedAlert("Expecting but did not find response parameter in StatMethod.cxx");
           }
           isRespar = true;
           Response* resp = rpj->responseParent();
           size_t specNum = resp->spectrumNumber();
           // calc (dR/dp)*M
           RealArray dr;
           resp->makeDerivative(delta, dr, rpj->parType());
           // calc dF/dp = d(R*M)/dp = (dR/dp)*M + R*(dM/dp)
           m_dRM[parNum] = ArrayContainer();
           m_dRM[parNum][specNum] = RealArray();
           RealArray& drm = m_dRM[parNum][specNum];
           drm.resize(dr.size());
           drm = dr;
           if (drm.size() != dm[specNum].size())
           {
              throw RedAlert("Response and folded model derivative array size mismatch");
           }
           drm += dm[specNum];
           
        }
	
	Real sum = sumDerivs(parNum, isRespar);
        // beta_i is defined as -.5*d(stat)/d(par_i)
        beta(np,-0.5*sum - s_bayes.dlPrior(fit, parNum));        
        ++np;
    }

    
    if ( fit->fitMethod()->secondDerivativeRequired() ) 
    {
        size_t ni (0);
        const size_t N(parNums.size());
        while ( ni <  N )
        {
	    int i = parNums[ni];
	    size_t nj (0);
	    while ( nj <= ni )
	    {
		int j = parNums[nj];
                Real alpha_ij = sumSecondDerivs(i, j, i>=respFloor, j>=respFloor);
		alpha(nj + N*ni,0.5*alpha_ij - s_bayes.d2lPrior(fit, i, j)) ;
		if (ni != nj ) alpha(ni + N*nj,0.5*alpha_ij);
		++nj; 
	    }  
	    ++ni; 
        }   
    }
	
  //## end StatMethod::analyticDifferentiate%45B0DB84028A.body
}

//## Get and Set Operations for Associations (implementation)

void StatMethod::weight (XSContainer::Weight* value)
{
  //## begin StatMethod::weight%3C4354EB0331.set preserve=yes
  delete m_weight;
  m_weight = value->clone();
  DataUtility::weightScheme(m_weight);
  //## end StatMethod::weight%3C4354EB0331.set
}

// Additional Declarations
  //## begin StatMethod%3A7EC4660115.declarations preserve=yes
  //## end StatMethod%3A7EC4660115.declarations

//## begin module%3B7AC09C018D.epilog preserve=yes
//## end module%3B7AC09C018D.epilog
